package executable;

import java.util.Iterator;
import java.util.Scanner;

import nodetypes.Expression;
import nodetypes.ExpressionFactory;
import visitors.ComputeVisitor;
import visitors.PrintVisitor;
import visitors.Visitor;

public class Arithmo {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		while(true) {
			String rawExpression = sc.nextLine();
			if(rawExpression.equals("quit")) {
				break;
			}
			
			rawExpression = rawExpression.replaceAll("\\s", "");
			Expression tree = ExpressionFactory.getInstance().constructAST(rawExpression);
			Visitor printer = new PrintVisitor();
			
			printer.visit(tree);
			System.out.println();
			
			Visitor calculator = new ComputeVisitor();
			System.out.println(calculator.visit(tree));
			
			StepByStepSolving sbsv = new StepByStepSolving(tree);
			Iterator<Expression> iter = sbsv.iterator();
			while(iter.hasNext()) {
				printer.visit(iter.next());
				System.out.println();
			}
		}
		sc.close();
	}

}
