package parsers;

import java.util.HashSet;
import java.util.Stack;
/**
 * 
 * @author arotaru
 *
 */

/*
 * rawExpression :  ((x0 + x1) * (y0 / (z0 - z1))) -> after parsing
 * leftExpression:  (x0 + x1)
 * operator:	    *
 * rightExpression: (y0 / (z0 - z1))
 */
public class ExpressionParser {
	static HashSet<Character> operators = new HashSet<Character>();
	{
		operators.add('+');
		operators.add('-');
		operators.add('*');
		operators.add('/');
		
		//bonus
		operators.add('-');
		operators.add('v');
	}
	
	public ExpressionParser(String rawexp) {
		rawExpression = rawexp;
		rightExpression = null;
		leftExpression = null;
		operator = null;
		_ParseExpression();
	}
	
	public ExpressionParser() {
		this(null);
	}
	
	public Character getOperator() {
		return operator;
	}
	
	public String leftExpression() {
		return leftExpression;
	}
	
	public String rightExpression() {
		return rightExpression;
	}
	
	/*
	 * Determinam care este operatorul si care sunt operanzii.
	 */
	private void _ParseExpression() {
		Stack<Character> myStack = new Stack<Character>();
		Character pushOnStack = '(';
		Character popStack = ')';
		int indexOfOperator = -1;
			
		for(int i = 0; i < rawExpression.length(); i++) {
			Character ch = rawExpression.charAt(i);
			if(ch.equals(pushOnStack)) {
				myStack.push(ch);
			} else if(ch.equals(popStack)) {
				myStack.pop();
			} else {
				// daca caracterul curent este o operatie si nu face parte dintr-o subexpresie
				if(operators.contains(ch) && myStack.size() == 1) {
					indexOfOperator = i;
					break;//am gasit operatorul
				}
			}
		}
		if(1 == indexOfOperator) {
			operator = rawExpression.charAt(indexOfOperator);
			leftExpression = rawExpression.substring(indexOfOperator + 1, rawExpression.length() - 1);
		} else if(-1 != indexOfOperator) { // inseamna ca avem 2 operanzi si un operator
			operator = rawExpression.charAt(indexOfOperator);
			leftExpression = rawExpression.substring(1, indexOfOperator); // incepem de la 1 ca sa scapam de prima paranteza
			rightExpression = rawExpression.substring(indexOfOperator + 1, rawExpression.length() - 1); // scapam de ultima paranteza
		} else {
			leftExpression = rawExpression; // daca nu o punem by default pe operandul stang
			
		}
	}
	
	@Override
	public String toString() {
		// doar pentru debug
		String r = "[" + leftExpression + "]" + operator + "[" + rightExpression + "]";		
		return r;
	}
	
	private String rawExpression;
	private String leftExpression;
	private String rightExpression;
	private Character operator;
}
