package visitors;

import nodetypes.*;
import nodetypes.binary.Addition;
import nodetypes.binary.Division;
import nodetypes.binary.Multiplication;
import nodetypes.binary.Subtraction;
import nodetypes.unary.Negative;
import nodetypes.unary.SquareRoot;

public interface Visitor {
	int visit(Expression exp);

	/*Binary Operations*/
	int visit(Addition a);
	int visit(Subtraction s);
	int visit(Multiplication m);
	int visit(Division d);
	
	/*Unary Operations*/
	int visit(Negative n);
	int visit(SquareRoot s);
	
	int visit(Value v);
}
